<template>
  <a-spin :spinning="saving">
    <a-form :form="form" layout="vertical">
      <a-form-item>
        <span slot="label">Email (An invitation will be sent to this email)</span>
        <a-input
          v-decorator="['email', {rules: [{ required: true, type: 'email', message: 'Please enter email address.' }], validateTrigger: ['change', 'blur']}]"
          placeholder="Emai"
        >
          <a-icon slot="prefix" :style="{ color: 'rgba(0,0,0,.25)' }" type="mail" />
        </a-input>
      </a-form-item>
      <a-form-item label="Name">
        <a-input v-decorator="['name', {type: 'text'}]" placeholder="Name" />
      </a-form-item>
      <a-form-item>
        <a-button @click="handleSubmit" block type="primary" size="large">
          Save
        </a-button>
      </a-form-item>
    </a-form>
  </a-spin>
</template>

<script>
import { usersApi } from '@/api'

export default {
  data () {
    return {
      saving: false,
      form: this.$form.createForm(this)
    }
  },
  methods: {
    handleSubmit (e) {
      e.preventDefault()
      const {
        form: { validateFields }
      } = this
      validateFields({ force: true }, (err, values) => {
        if (!err) {
          // eslint-disable-next-line no-unused-vars
          const { email, name = '' } = values
          this.saving = true
          const params = {
            userName: email,
            email,
            name
          }
          usersApi.createUser(params)
            .then((User) => {
              this.$emit('result', {
                successful: true,
                message: 'Successful create user',
                data: User
              })
            })
            .catch(error =>
              this.$emit('result', {
                successful: false,
                message: 'エラーが起こりました。後でやり直してください' || error
              })
            )
            .finally(() => (this.saving = false))
        }
      })
    }
  }
}
</script>

<style>
</style>
